Summary: Monitor the progress of data through a pipe.
Name: pv
Version: 0.2.6
Release: 1
Copyright: Artistic
Group: Development/Tools
Source: http://www.ivarch.com/programs/sources/pv-0.2.6.tar.gz
BuildRoot: /var/tmp/%{name}-%{version}-root

%description
PV ("Pipe Viewer") is a tool for monitoring the progress of data through a
pipeline.  It can be inserted into any normal pipeline between two processes
to give a visual indication of how quickly data is passing through, how long
it has taken, how near to completion it is, and an estimate of how long it
will be until completion.

%prep
%setup

%build
CFLAGS="$RPM_OPT_FLAGS" sh ./configure \
  --prefix=/usr \
  --infodir=/usr/share/info \
  --mandir=/usr/share/man \
  --sysconfdir=/etc
make

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"
[ -e "$RPM_BUILD_ROOT" ] || mkdir -m 755 "$RPM_BUILD_ROOT"
[ -e "$RPM_BUILD_ROOT/etc" ] || mkdir -m 755 "$RPM_BUILD_ROOT/etc"
[ -e "$RPM_BUILD_ROOT/usr" ] || mkdir -m 755 "$RPM_BUILD_ROOT/usr"
[ -e "$RPM_BUILD_ROOT/usr/bin" ] || mkdir -m 755 "$RPM_BUILD_ROOT/usr/bin"
[ -e "$RPM_BUILD_ROOT/usr/share" ] || mkdir -m 755 "$RPM_BUILD_ROOT/usr/share"
[ -e "$RPM_BUILD_ROOT/usr/share/man" ] || mkdir -m 755 "$RPM_BUILD_ROOT/usr/share/man"
[ -e "$RPM_BUILD_ROOT/usr/share/man/man1" ] || mkdir -m 755 "$RPM_BUILD_ROOT/usr/share/man/man1"
[ -e "$RPM_BUILD_ROOT/usr/share/info" ] || mkdir -m 755 "$RPM_BUILD_ROOT/usr/share/info"
[ -e "$RPM_BUILD_ROOT/usr/share/locale" ] || mkdir -m 755 "$RPM_BUILD_ROOT/usr/share/locale"
make install

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf "$RPM_BUILD_ROOT"

%pre

%post
[ -x /sbin/install-info ] \
&& [ -e /usr/share/info/dir ] \
&& /sbin/install-info /usr/share/info/pv.info.gz /usr/share/info/dir

%preun
[ -x /sbin/install-info ] \
&& [ -e /usr/share/info/dir ] \
&& /sbin/install-info --delete /usr/share/info/pv.info.gz \
                               /usr/share/info/dir

%postun

%files
%defattr(-, root, root)
/usr/bin/*
%docdir /usr/share/man/man1
%docdir /usr/share/info
/usr/share/man/man1/*
/usr/share/info/*
/usr/share/locale/*/LC_MESSAGES/*
%doc README doc/NEWS doc/TODO doc/COPYING

%changelog
* Tue Jul 16 2002 Andrew Wood <andrew.wood@ivarch.com>
- first draft of spec file created
