#ifndef LIBRARIES_ATARI2600_H
#define LIBRARIES_ATARI2600_H
/*
**	$VER: atari2600.h 2.2 (29.10.99)
**
**	atari2600 library definitions
**
**	(C) Copyright 1999 Neil Cafferkey
**	All Rights Reserved
*/


#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif /* UTILITY_TAGITEM_H */


#define ATARI2600NAME "atari2600.library"
#define ATARI2600VERSION 2L

/* Various constants */

#define A2600_CLR_CLK_FACTOR 3

#define A2600_TV_WIDTH 160

#define A2600_H_BLANK_CYCLES 68
#define A2600_LINE_CYCLES H_BLANK_CYCLES+TV_WIDTH

/* Addresses of Atari 2600 read registers */

#define A2600_CXM0P  0x0
#define A2600_CXM1P 0x1
#define A2600_CXP0FB 0x2
#define A2600_CXP1FB 0x3
#define A2600_CXM0FB 0x4
#define A2600_CXM1FB 0x5
#define A2600_CXBLPF 0x6
#define A2600_CXPPMM 0x7
#define A2600_INPT0 0x8
#define A2600_INPT1 0x9
#define A2600_INPT2 0xa
#define A2600_INPT3 0xb
#define A2600_INPT4 0xc
#define A2600_INPT5 0xd

#define A2600_SWCHA 0x280
#define A2600_SWCHB 0x282

/* Tags for a new environment */

#define A2600TAG_ProgramName TAG_USER
#define A2600TAG_ExitFunction TAG_USER+1

/* New tag for V2 */

#define A2600TAG_WBMsg TAG_USER+2

/* Obsolete */

#define A2600_TV_HEIGHT 230


#endif /* LIBRARIES_ATARI2600_H */
