/*

File: bank_protos.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _bank_protos_h
#define _bank_protos_h


#include "bank.h"


/* Function: CreateBank
 * ====================
 * Creates a Bank.
 */

Bank CreateBank(MemType mem_type,ULONG original_base,TEXT *file_name,
   UWORD bank_no);


/* Function: ReadBank
 * ==================
 * Reads a bank into memory from a file;
 */

Bank ReadBank(TEXT *file_name);


/* Function: PutAddressInBank
 * ==========================
 */

VOID PutAddressInBank(Bank bank,Address address);


/* Function: GetBankAddress
 * ========================
 */

Address GetBankAddress(Bank bank,ULONG offset);


/* Function: GetBankContents
 * =========================
 */

UBYTE *GetBankContents(Bank bank,ULONG offset);


/* Function: OffsetIsInBank
 * ========================
 */

BOOL OffsetIsInBank(Bank bank,ULONG offset);


/* Function: GetBankBase
 * =====================
 */

ULONG GetBankBase(Bank bank);


/* Function: GetBankLength
 * =======================
 */

ULONG GetBankLength(Bank bank);


/* Function: GetBankNumber
 * =======================
 */

UWORD GetBankNumber(Bank bank);


/* Function: GetBankDataFileName
 * =============================
 */

TEXT *GetBankDataFileName(Bank bank);


/* Function: KillBank
 * ==================
 */

VOID KillBank(Bank bank);


#endif


