/*

File: config_protos.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _config_protos_h
#define _config_protos_h


#include "config.h"
#include "string_set.h"


/* Function: ReadConfig
 * ====================
 * Makes a config from the contents of a file.
 */

Config ReadConfig(TEXT *file_name);


/* Function: GetStringConfigOption
 * ===============================
 */

TEXT *GetStringConfigOption(Config config,TEXT *heading);


/* Function: GetNumericConfigOption
 * ================================
 */

ULONG GetNumericConfigOption(Config config,TEXT *heading);


/* Function: GetStringSetConfigOption
 * ==================================
 */

StringSet GetStringSetConfigOption(Config config,TEXT *heading);


/* Function: KillConfig
 * ====================
 */

VOID KillConfig(Config config);


#endif


