/*

File: cpu_protos.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _cpu_protos_h
#define _cpu_protos_h


#include "cpu.h"
#include "address.h"
#include "instruction.h"
#include "source_program.h"


/* Function: CreateCPU
 * ===================
 */

CPU CreateCPU(TEXT *name,InstructionSet instructions,
   ULONG interrupt_vector);


/* Function: ReadCPU
 * =================
 */

CPU ReadCPU(TEXT *file_name);


/* Function: GetCPUInstruction
 * ===========================
 */

Instruction GetCPUInstruction(CPU cpu,Address address,
   SourceProgram src_prog);


/* Function: GetCPUInterruptVector
 * ===============================
 */

ULONG GetCPUInterruptVector(CPU cpu);


/* Function: KillCPU
 * =================
 */

VOID KillCPU(CPU cpu);


#endif


