/*

File: general.c
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#include "general_protos.h"
#include "memory_protos.h"


/* Function: FileRead
 * ==================
 * Reads data from a file at the current offset, allocating the memory
 * needed.
 */

VOID *FileRead(ULONG length,FILE *file)
{
   UBYTE *buffer;

   buffer=Malloc(length*sizeof(UBYTE));
   fread(buffer,sizeof(UBYTE),length,file);
   return buffer;
}


/* Function: FileWrite
 * ===================
 * Writes data to a file at a specified offset.
 */

BOOL FileWrite(ULONG length,UBYTE *buffer,FILE *file,ULONG file_offset)
{
   return fseek(file,file_offset,SEEK_SET)
      ||fwrite(buffer,sizeof(UBYTE),length,file);
}


VOID MemCopy(ULONG length,UBYTE *source_buf,UBYTE *target_buf)
{
   ULONG i;

   for(i=0;i<length;i++) *(target_buf++)=*(source_buf++);
   return;
}

UWORD GetLittleEndianUWord(UBYTE *data)
{
   return (*data+*(data+1)*0x100);
}


