/*

File: general_protos.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _general_protos_h
#define _general_protos_h


#include "exec/types.h"
#include <stdio.h>


/* Function: FileRead
 * ==================
 * Reads data from a file at the current offset, allocating the memory
 * needed.
 */

VOID *FileRead(ULONG length,FILE *file);


/* Function: FileWrite
 * ===================
 * Writes data to a file at a specified offset.
 */

BOOL FileWrite(ULONG length,UBYTE *buffer,FILE *file,ULONG file_offset);


VOID MemCopy(ULONG length,UBYTE *source_buf,UBYTE *target_buf);


UWORD GetLittleEndianUWord(UBYTE *data);


#endif


