/*

File: machine_protos.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _machine_protos_h
#define _machine_protos_h


#include "machine.h"
#include "address.h"
#include "source_program.h"


/* Function: CreateMachine
 * =======================
 */

Machine CreateMachine(TEXT *name,CPU cpu,LONGBITS address_mask,
   InstructionSet instructions,ULONG entry_vector);


/* Function: ReadMachine
 * =====================
 */

Machine ReadMachine(TEXT *file_name);


/* Function: GetMachineInstruction
 * ===============================
 */

Instruction GetMachineInstruction(Machine machine,Address address,
   SourceProgram src_prog);


/* Function: GetMachineAddressMask
 * ===============================
 */

LONGBITS GetMachineAddressMask(Machine machine);


/* Function: GetMachineEntryVector
 * ===============================
 */

ULONG GetMachineEntryVector(Machine machine);


/* Function: GetMachineInterruptVector
 * ===================================
 */

ULONG GetMachineInterruptVector(Machine machine);


/* Function: KillMachine
 * =====================
 */

VOID KillMachine(Machine machine);


#endif


