/*

File: segment_protos.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _segment_protos_h
#define _segment_protos_h


#include "segment.h"


/* Function: CreateSegment
 * =======================
 * Creates a Segment.
 */

Segment CreateSegment(ULONG original_base,ULONG size);


/* Function: ReadSegment
 * =====================
 */

Segment ReadSegment(TEXT *file_name);


/* Function: PutBankInSegment
 * ==========================
 */

VOID PutBankInSegment(Segment segment,Bank bank);


/* Function: GetSegmentBank
 * ========================
 */

Bank GetSegmentBank(Segment segment,ULONG bank_no);


/* Function: OffsetIsInSegment
 * ===========================
 */

BOOL OffsetIsInSegment(Segment segment,ULONG offset);


/* Function: KillSegment
 * =====================
 */

VOID KillSegment(Segment segment);


#endif


