/*

File: set_protos.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _set_protos_h
#define _set_protos_h

#include "exec/types.h"
#include "set.h"


/* Function: CreateSet
 * ===================
 * Creates a Set.
 */

Set CreateSet(VOID);

VOID PutInSet(Set set,APTR element);

APTR TakeFromSet(Set set);

BOOL IsInSet(Set set,APTR element);

BOOL IsEmptySet(Set set);

ULONG GetSetSize(Set set);

Set DupSet(Set source);


/* Function: SearchSet
 * ===================
 */

APTR SearchSet(Set set,APTR test_element);


/* Function: KillSet
 * =================
 */

VOID KillSet(Set set);


/* Function: ShowSet
 * =================
 * Prints out the contents of the element set for testing.
 */

VOID ShowSet(Set set);


#endif


