/*

File: source_program.h
Author: Neil Cafferkey
Copyright (C) 1999-2001 Neil Cafferkey

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA.

*/

#ifndef _source_program_h
#define _source_program_h

#include "exec/types.h"

#include "segment.h"
#include "machine.h"
#include "address_set.h"
#include "reverse_graph.h"
#include "instruction_set.h"


#define MAX_SEG_COUNT 100

typedef struct
{
   TEXT *name;
   UWORD year;
   TEXT *owner;
   Machine machine;
   ULONG segment_count;
   Segment segments[MAX_SEG_COUNT];
   AddressSet closure;
   AddressSet revisit_agenda;
   ReverseGraph rev_graph;
   InstructionSet instructions;
}
SourceProgram_imp;

typedef SourceProgram_imp *SourceProgram;

#endif


