; File: Riot.i
; Author: Neil Cafferkey
; ======================
; These are replacements for instructions that access the Riot chip
;
; $VER: Riot.i 2.1 (25.8.99)
;

	ifnd	riot_i
riot_i	set	1


SWCHA	equ	$280
SWCHB	equ	$282


; Macro: WSWCHA
; =============
;

	macro	WSWCHA

	addq.l	#4,CLOCK

	endm


; Macro: SWACNT
; =============
;

	macro	SWACNT

	addq.l	#4,CLOCK

	endm


; Macro: SWBCNT
; =============
;

	macro	SWBCNT

	addq.l	#4,CLOCK

	endm


; Macro: INTIM
; ============
;

	macro	INTIM

	; Update clock cycle counter

	addq.l	#4,CLOCK

	; Call library function corresponding to this macro

	move.l	CLOCK,d1
	movea.l	ENV,a1
	CALLSYS	A2600_InTim

	; Store result

	move.b	d0,\1

	endm


; Macro: TIM1T
; ============
;

	macro	TIM1T

	; Update clock cycle counter

	addq.l	#4,CLOCK

	; Call library function corresponding to this macro

	move.l	\1,d0
	move.l	CLOCK,d1
	movea.l	ENV,a1
	CALLSYS	A2600_Tim1T

	endm


; Macro: TIM8T
; ============
;

	macro	TIM8T

	; Update clock cycle counter

	addq.l	#4,CLOCK

	; Call library function corresponding to this macro

	move.l	\1,d0
	move.l	CLOCK,d1
	movea.l	ENV,a1
	CALLSYS	A2600_Tim8T

	endm


; Macro: TIM64T
; =============
;

	macro	TIM64T

	; Update clock cycle counter

	addq.l	#4,CLOCK

	; Call library function corresponding to this macro

	move.l	\1,d0
	move.l	CLOCK,d1
	movea.l	ENV,a1
	CALLSYS	A2600_Tim64T

	endm


; Macro: T1024T
; =============
;

	macro	T1024T

	; Update clock cycle counter

	addq.l	#4,CLOCK

	; Call library function corresponding to this macro

	move.l	\1,d0
	move.l	CLOCK,d1
	movea.l	ENV,a1
	CALLSYS	A2600_Tim1024T

	endm


	endc

