/************************************************************
 *
 * Alcuin: A HP48 emulator for Amiga Computer
 *
 * Copyright (c) 1995 by Stephan Schupfer <schupfer@sbox.tu-graz.ac.at>
 *
 */

#include "hp48.h"
#include "device.h"
#include "timer.h"

extern int device_check;

device_t device;

/************************************************************/
void check_devices(void)
{
if (device.contrast_touched) {
	device.contrast_touched = 0;
	adjust_contrast(display_contrast);
	}
if (device.display_touched) {
	device.display_touched = 0;
	if (display_on) update_display();
	}
/*if (device.display_touched > 0) device_check = 1;*/
/*if (device.ann_touched) {
	device.ann_touched = 0;
	draw_annunc();
	}
if (device.baud_touched) {
	device.baud_touched = 0;
	serial_baud(saturn_baud);
	}
if (device.ioc_touched) {
	device.ioc_touched = 0;
	if ((saturn_io_ctrl & 0x02) && (saturn_rcs & 0x01)) {
		do_interupt();
		}
	}
*/
if (device.t1_touched) {
	saturn_t1_instr = 0;
	sched_timer1 = saturn_t1_tick;
	restart_timer(T1_TIMER);
	set_t1 = saturn_timer1;
	device.t1_touched = 0;
	}
if (device.t2_touched) {
	saturn_t2_instr = 0;
	sched_timer2 = saturn_t2_tick;
	device.t2_touched = 0;
	}

if (device.tbr_touched) {
	device.tbr_touched = 0;
	transmit_char();
	}
if (device.rbr_touched) {
	device.rbr_touched = 0;
	receive_char();
	}
#if 0
  if (device.disp_test_touched) {
    device.disp_test_touched = 0;
  }
  if (device.crc_touched) {
    device.crc_touched = 0;
  }
  if (device.power_status_touched) {
    device.power_status_touched = 0;
  }
  if (device.power_ctrl_touched) {
    device.power_ctrl_touched = 0;
  }
  if (device.mode_touched) {
    device.mode_touched = 0;
  }
  if (device.card_ctrl_touched) {
    device.card_ctrl_touched = 0;
  }
  if (device.card_status_touched) {
    device.card_status_touched = 0;
  }
  if (device.tcs_touched) {
    device.tcs_touched = 0;
  }
  if (device.rcs_touched) {
    device.rcs_touched = 0;
  }
  if (device.sreq_touched) {
    device.sreq_touched = 0;
  }
  if (device.ir_ctrl_touched) {
    device.ir_ctrl_touched = 0;
  }
  if (device.base_off_touched) {
    device.base_off_touched = 0;
  }
  if (device.lcr_touched) {
    device.lcr_touched = 0;
  }
  if (device.lbr_touched) {
    device.lbr_touched = 0;
  }
  if (device.scratch_touched) {
    device.scratch_touched = 0;
  }
  if (device.base_nibble_touched) {
    device.base_nibble_touched = 0;
  }
  if (device.unknown_touched) {
    device.unknown_touched = 0;
  }
  if (device.t1_ctrl_touched) {
    device.t1_ctrl_touched = 0;
  }
  if (device.t2_ctrl_touched) {
    device.t2_ctrl_touched = 0;
  }
  if (device.unknown2_touched) {
    device.unknown2_touched = 0;
  }
#endif
}
