/***************************************************************
 *  Alcuin: A HP48 emulator for Amiga Computers
 * 
 *  (C) 1995 Stephan Schupfer (schupfer@sbox.tu-graz.ac.at)
 *
 */

/************************************************************/
static inline void add_con_p(unsigned char *r,int val,unsigned char i)
{
r[i]+=val;
saturn_CARRY=hex_carry[r[i]];
r[i]&=0xf;
}

/************************************************************/
static inline void add_con_wp(unsigned char *r,int val)
{
int i;

saturn_CARRY=val;
for (i = 0; i <= saturn_P; i++) {
	r[i]+=saturn_CARRY;
	saturn_CARRY=hex_carry[r[i]];
	r[i]&=0xf;
	if (!saturn_CARRY) return;
	}
}

/************************************************************/
static inline void add_con_x(unsigned char *r,int val)
{
int i;

saturn_CARRY=val;
for (i = 0; i < 3; i++) {
	r[i]+=saturn_CARRY;
	saturn_CARRY=hex_carry[r[i]];
	r[i]&=0xf;
	if (!saturn_CARRY) return;
	}
}

/************************************************************/
static inline void add_con_m(unsigned char *r,int val)
{
int i;

saturn_CARRY=val;
for (i = 3; i < 15; i++) {
	r[i]+=saturn_CARRY;
	saturn_CARRY=hex_carry[r[i]];
	r[i]&=0xf;
	if (!saturn_CARRY) return;
	}
}

/************************************************************/
static inline void add_con_b(unsigned char *r,int val)
{
*r+=val;
r[1]+=*r>>4;
saturn_CARRY=hex_carry[r[1]];
*r&=0xf;
r[1]&=0xf;
}

/************************************************************/
static inline void add_con_w(unsigned char *r,int val)
{
int i;

saturn_CARRY=val;
for (i = 0; i < 16; i++) {
	r[i]+=saturn_CARRY;
	saturn_CARRY=hex_carry[r[i]];
	r[i]&=0xf;
	if (!saturn_CARRY) return;
	}
}

/************************************************************/
static inline void add_con_a(unsigned char *r,int val)
{
int i;

saturn_CARRY=val;
for (i = 0; i < 5; i++) {
	r[i]+=saturn_CARRY;
	saturn_CARRY=hex_carry[r[i]];
	r[i]&=0xf;
	if (!saturn_CARRY) return;
	}
}

/************************************************************/
