/***************************************************************
 *  Alcuin: A HP48 emulator for Amiga Computers
 * 
 *  (C) 1995 Stephan Schupfer (schupfer@sbox.tu-graz.ac.at)
 *
 */

#define not_p(d, c)  (saturn_hexmode ? not_p_hex (d, c) : not_p_bcd (d, c))
#define not_wp(d) (saturn_hexmode ? not_wp_hex (d) : not_wp_bcd (d))
#define not_x(d)  (saturn_hexmode ? not_x_hex (d) : not_x_bcd (d))
#define not_m(d)  (saturn_hexmode ? not_m_hex (d) : not_m_bcd (d))
#define not_b(d)  (saturn_hexmode ? not_b_hex (d) : not_b_bcd (d))
#define not_w(d)  (saturn_hexmode ? not_w_hex (d) : not_w_bcd (d))
#define not_a(d)  (saturn_hexmode ? not_a_hex (d) : not_a_bcd (d))

static unsigned char not_nib[16]={15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0};

/************************************************************/
static inline void not_p_hex(unsigned char *r,unsigned char i)
{
r[i]=not_nib[r[i]];
saturn_CARRY=0;
}

/************************************************************/
static inline void not_p_bcd(unsigned char *r,unsigned char i)
{
r[i]=not_bcd_nibble[r[i]];
saturn_CARRY=0;
}

/************************************************************/
static inline void not_wp_hex(unsigned char *r)
{
int i=saturn_P+1;

while (i--) {
	r[i]=not_nib[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_wp_bcd(unsigned char *r)
{
int i=saturn_P+1;

while (i--) {
	r[i]=not_bcd_nibble[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_x_hex(unsigned char *r)
{
int i=3;

while (i--) {
	r[i]=not_nib[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_x_bcd(unsigned char *r)
{
int i=3;

while (i--) {
	r[i]=not_bcd_nibble[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_m_hex(unsigned char *r)
{
int i;

for (i = 3; i < 15; i++) {
	r[i]=not_nib[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_m_bcd(unsigned char *r)
{
int i;

for (i = 3; i < 15; i++) {
	r[i]=not_bcd_nibble[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_b_hex(unsigned char *r)
{
*r=not_nib[*r];
r[1]=not_nib[r[1]];
saturn_CARRY=0;
}

/************************************************************/
static inline void not_b_bcd(unsigned char *r)
{
*r=not_bcd_nibble[*r];
r[1]=not_bcd_nibble[r[1]];
saturn_CARRY=0;
}

/************************************************************/
static inline void not_w_hex(unsigned char *r)
{
int i=16;

while (i--) {
	r[i]=not_nib[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_w_bcd(unsigned char *r)
{
int i=16;

while (i--) {
	r[i]=not_bcd_nibble[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_a_hex(unsigned char *r)
{
int i=5;

while (i--) {
	r[i]=not_nib[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
static inline void not_a_bcd(unsigned char *r)
{
int i=5;

while (i--) {
	r[i]=not_bcd_nibble[r[i]];
	}
saturn_CARRY=0;
}

/************************************************************/
