/***************************************************************
 *  Alcuin: A HP48 emulator for Amiga Computers
 * 
 *  (C) 1995 Stephan Schupfer (schupfer@sbox.tu-graz.ac.at)
 *
 */

/******************************************************************/
static inline word_20 read_simm_2 ()
{
return (last_op[2] | (last_op[3] << 4));
}

/******************************************************************/
static inline word_20 read_simm_4 ()
{
return (last_op[2] | (last_op[3] << 4) | (last_op[4] << 8) | (last_op[5] << 12));
}

/******************************************************************/
static inline word_20 read_simm_5 ()
{
return (last_op[2] | (last_op[3] << 4) | (last_op[4] << 8) | (last_op[5] << 12) | (last_op[6] << 16));
}

/******************************************************************/
static inline void read_limm_2 (unsigned char *con64)
{
memcpy(con64,lop2,2);
}

/******************************************************************/
static inline void read_limm_3 (unsigned char *con64)
{
memcpy(con64,lop2,3);
}

/******************************************************************/
static inline void read_limm_4 (unsigned char *con64)
{
memcpy(con64,lop2,4);
}

/******************************************************************/
static inline void read_limm_5 (unsigned char *con64)
{
memcpy(con64,lop2,5);
}

/******************************************************************/
static inline void read_limm_6 (unsigned char *con64)
{
memcpy(con64,lop2,6);
}

/******************************************************************/
static inline void read_limm_7 (unsigned char *con64)
{
memcpy(con64,lop2,7);
}

/******************************************************************/
static inline void read_limm_8 (unsigned char *con64)
{
memcpy(con64,lop2,8);
}

/******************************************************************/
static inline void read_limm_9 (unsigned char *con64)
{
memcpy(con64,lop2,9);
}

/******************************************************************/
static inline void read_limm_10 (unsigned char *con64)
{
memcpy(con64,lop2,10);
}

/******************************************************************/
static inline void read_limm_11 (unsigned char *con64)
{
memcpy(con64,lop2,11);
}

/******************************************************************/
static inline void read_limm_12 (unsigned char *con64)
{
memcpy(con64,lop2,12);
}

/******************************************************************/
static inline void read_limm_13 (unsigned char *con64)
{
memcpy(con64,lop2,13);
}

/******************************************************************/
static inline void read_limm_14 (unsigned char *con64)
{
memcpy(con64,lop2,14);
}

/******************************************************************/
static inline void read_limm_15 (unsigned char *con64)
{
memcpy(con64,lop2,15);
}

/******************************************************************/
static inline void read_limm_16 (unsigned char *con64)
{
memcpy(con64,lop2,16);
}

/******************************************************************/
static inline void read_limm_2b (unsigned char *con64)
{
memcpy(con64,lop5,2);
}

/******************************************************************/
static inline void read_limm_3b (unsigned char *con64)
{
memcpy(con64,lop5,3);
}

/******************************************************************/
static inline void read_limm_4b (unsigned char *con64)
{
memcpy(con64,lop5,4);
}

/******************************************************************/
static inline void read_limm_5b (unsigned char *con64)
{
memcpy(con64,lop5,5);
}

/******************************************************************/
static inline void read_limm_6b (unsigned char *con64)
{
memcpy(con64,lop5,6);
}

/******************************************************************/
static inline void read_limm_7b (unsigned char *con64)
{
memcpy(con64,lop5,7);
}

/******************************************************************/
static inline void read_limm_8b (unsigned char *con64)
{
memcpy(con64,lop5,8);
}

/******************************************************************/
static inline void read_limm_9b (unsigned char *con64)
{
memcpy(con64,lop5,9);
}

/******************************************************************/
static inline void read_limm_10b (unsigned char *con64)
{
memcpy(con64,lop5,10);
}

/******************************************************************/
static inline void read_limm_11b (unsigned char *con64)
{
memcpy(con64,lop5,11);
}

/******************************************************************/
static inline void read_limm_12b (unsigned char *con64)
{
memcpy(con64,lop5,12);
}

/******************************************************************/
static inline void read_limm_13b (unsigned char *con64)
{
memcpy(con64,lop5,13);
}

/******************************************************************/
static inline void read_limm_14b (unsigned char *con64)
{
memcpy(con64,lop5,14);
}

/******************************************************************/
static inline void read_limm_15b (unsigned char *con64)
{
memcpy(con64,lop5,15);
}

/******************************************************************/
static inline void read_limm_16b (unsigned char *con64)
{
memcpy(con64,lop5,16);
}

/******************************************************************/
static inline void read_bra_2 ()
{
long rel;
long offset;

offset=saturn_PC + 1;
rel=last_op[1] | (last_op[2] << 4);
if (!rel) saturn_PC = pop();
else {
	if (rel & 0x80)
	rel |= 0xffffff80;
	saturn_PC = (rel+offset) & 0xfffff;
	}
}

/******************************************************************/
static inline void read_bra_2b ()
{
long rel;
long offset;

offset=saturn_PC + 5;
rel=last_op[5] | (last_op[6] << 4);
if (!rel) saturn_PC = pop();
else {
	if (rel & 0x80)
	rel |= 0xffffff80;
	saturn_PC = (rel+offset) & 0xfffff;
	}
}

/******************************************************************/
static inline void read_bra_2c ()
{
long rel;
long offset;

offset=saturn_PC + 3;
rel=last_op[3] | (last_op[4] << 4);
if (!rel) saturn_PC = pop();
else {
	if (rel & 0x80)
		rel |= 0xffffff80;
	saturn_PC = (rel+offset) & 0xfffff;
	}
}

/******************************************************************/
static inline void read_bra_3 ()
{
long rel;

rel=last_op[1] | (last_op[2] << 4) | (last_op[3] << 8);
if (rel == 4) {
	/* NOP5, emucall ... */
	if (last_op[4]==1) {
		stirb("Illegal instruction at %.5lX.",112,saturn_PC);
		}
	}
if (rel & 0x800) rel |= 0xfffff800;
saturn_PC += rel + 1;
saturn_PC &= 0xfffff;
}

/******************************************************************/
static inline void read_bra_4 ()
{
long rel;

rel=(last_op[2] | (last_op[3] << 4) | (last_op[4] << 8) | (last_op[5] << 12));
if (rel & 0x8000) rel |= 0xffff8000;
saturn_PC += rel + 2;
saturn_PC &= 0xfffff;
}

/******************************************************************/
static inline void read_bsr_3 ()
{
long rel;

rel=last_op[1] | (last_op[2] << 4) | (last_op[3] << 8);
if (rel & 0x800)
	rel |= 0xfffff800;
saturn_PC += rel + 4;
saturn_PC &= 0xfffff;
}

/******************************************************************/
static inline void read_bsr_4 ()
{
long rel;

rel=(last_op[2] | (last_op[3] << 4) | (last_op[4] << 8) | (last_op[5] << 12));
if (rel & 0x8000)
	rel |= 0xffff8000;
saturn_PC += rel + 6;
saturn_PC &= 0xfffff;
}

/******************************************************************/
static inline void read_abs_5 ()
{
saturn_PC=(last_op[2] | (last_op[3] << 4) | (last_op[4] << 8) | (last_op[5] << 12) | (last_op[6] << 16));
}

/******************************************************************/
