#ifndef LIBRARIES_TTENGINE_H
#define LIBRARIES_TTENGINE_H

/* $VER: ttengine.h 5.0 (26.11.2002) (c) by Grzegorz Kraszewski 2002. */

#define TTENGINENAME "ttengine.library"
#define TTENGINEVERSION 5
#define TTENGINEMINVERSION 3

/* Tags */

/* Tags applicability legend: */
/* O - TT_OpenFont() */
/* G - TT_GetAttrs() */
/* S - TT_SetAttrs() */
/* P - TT_GetGrayPixmap() */

/* ---- name -------------------- value ----- applicability */

#define TT_FontFile             0x6EDA0000    /* OG.. */
#define TT_FontStyle            0x6EDA0001    /* OG.. */
#define TT_FontStyle_Regular    0
#define TT_FontStyle_Italic     1
#define TT_FamilyTable          0x6EDA0002    /* O... */
#define TT_FontSize             0x6EDA0003    /* OG.. */
#define TT_FontWeight           0x6EDA0004    /* OG.. */
#define TT_FontWeight_Normal    400
#define TT_FontWeight_Bold      700
#define TT_ColorMap             0x6EDA0005    /* O... */
#define TT_Screen               0x6EDA0006    /* O... */
#define TT_Window               0x6EDA0007    /* O... */
#define TT_FontAscender         0x6EDA0008    /* .G.. */
#define TT_FontDescender        0x6EDA0009    /* .G.. */
#define TT_Antialias            0x6EDA000F    /* .GSP */
#define TT_Antialias_Auto       0
#define TT_Antialias_Off        1
#define TT_Antialias_On         2
#define TT_Encoding             0x6EDA0010    /* .GSP */
#define TT_Encoding_Default     0             /* use ENV:ttfcodepage or ISO-8859-1 if not found */
#define TT_Encoding_Unicode     1             /* requires 16-bit string */
#define TT_Encoding_ISO8859_1   2             /* Western Europe and US */
#define TT_Encoding_ISO8859_2   3             /* Eastern Europe */
#define TT_Encoding_WideUnicode 4             /* requires 32-bit string */
#define TT_FontName             0x6EDA0011    /* .G.. */
#define TT_FamilyName           0x6EDA0012    /* .G.. */
#define TT_SubfamilyName        0x6EDA0013    /* .G.. */
#define TT_Transparency         0x6EDA0014    /* .GS.  from 0 to 255 */
#define TT_ScaleX               0x6EDA0015    /* O.SP  single precision floating point +- 0.01 to 100 */
#define TT_ScaleY               0x6EDA0016    /* O.SP  single precision floating point +- 0.01 to 100 */
#define TT_SoftStyle            0x6EDA0017    /* ..SP (V5) */
#define TT_SoftStyle_None           0x0000
#define TT_SoftStyle_Underlined     0x0001
#define TT_SoftStyle_DblUnderlined  0x0002
#define TT_SoftStyle_Overstriked    0x0004
#define TT_SoftStyle_DblOverstriked 0x0008
#define TT_Foreground           0x6EDA0018    /* ..S.  foreground RGB value*/
#define TT_Foreground_UseRastPort       -1
#define TT_Background           0x6EDA0019    /* ..S.  background RGB value*/
#define TT_Background_UseRastPort       -1

/* Structure returned by TT_GetPixmap() (V5)*/

struct TT_Pixmap
  {
    ULONG     ttp_Size;       /* size of the structure inculdung this field */
    ULONG     ttp_Width;      /* also equal to bytes per row */
    ULONG     ttp_Height;     /* number of rows */
    UBYTE    *ttp_Data;       /* grayscale pixmap data */
  };

#endif /* LIBRARIES_TTENGINE_H */

