
struct note_t
{
  char songname[16];
  char channels;
  int sample_rate;
  unsigned int samples_per_beat;
  int bpm;
  int bytes;
  int scale;
  int prev_scale;
  int tone;
  int length;
  int modifier;
  int style;
  int transpose;
  int flats;
  int a440,ats;
  int headers,full_sms_size;
  int width,height,mcc,mnc,bmp_flags;
  int note_count;
  int marker;
};

int write_long(FILE *out, int n);
int write_word(FILE *out, int n);
int read_long(FILE *in);
int read_word(FILE *in);
int write_long_b(FILE *out, int n);
int write_word_b(FILE *out, int n);
int read_long_b(FILE *in);
int read_word_b(FILE *in);
int read_chars(FILE *in, char *s, int count);
int write_chars(FILE *out, char *s);

void write_wav_header(FILE *out, struct note_t *note);
void write_wav_note(FILE *out, struct note_t *note);
void write_wav_footer(FILE *out, struct note_t *note);

void write_kws_header(FILE *out, struct note_t *note);
void write_kws_note(FILE *out, struct note_t *note);
void write_kws_footer(FILE *out, struct note_t *note);

void write_mot_header(FILE *out, struct note_t *note);
void write_mot_note(FILE *out, struct note_t *note);
void write_mot_footer(FILE *out, struct note_t *note);

void write_rtttl_header(FILE *out, struct note_t *note);
void write_rtttl_note(FILE *out, struct note_t *note);
void write_rtttl_footer(FILE *out, struct note_t *note);

void write_samsung_header(FILE *out, struct note_t *note);
void write_samsung1_note(FILE *out, struct note_t *note);
void write_samsung2_note(FILE *out, struct note_t *note);
void write_samsung_footer(FILE *out, struct note_t *note);

int header_route(FILE *out, struct note_t *note, int in_type, int file_type);
int note_route(FILE *out, struct note_t *note, int in_type, int file_type);
int footer_route(FILE *out, struct note_t *note, int in_type, int file_type);
int tempo_route(FILE *out, struct note_t *note, int in_type, int file_type);

int parse_rtttl(char *filename, char *outname, int file_type, struct note_t *note);
int parse_imelody(char *filename, char *outname, int file_type, struct note_t *note);
int wav2pdb(char *infile, char *outfile, struct note_t *note);
int parse_logo(char *filename, char *outname, int in_type, int file_type, struct note_t *note, char *message);
int parse_midi(char *filename, char *outname, int file_type, struct note_t *note);
int parse_kws(char *filename, char *outname, int file_type, struct note_t *note);
int parse_wav(char *filename, char *outname, int file_type, struct note_t *note);


