#include <stdio.h>
#include <stdlib.h>

#include "fileoutput.h"
#include "nokia.h"

/*

Ringtonetools - Copyright 2001-2002 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://nakentone.naken.cc/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

/* Motorola */

void write_mot_header(FILE *out, struct note_t *note)
{
char outchars[10];
int tempo;

  tempo=2;
  sprintf(outchars,"L35&%d ",tempo);
  write_chars(out,outchars);
}

void write_mot_note(FILE *out, struct note_t *note)
{
char outnote[10];
char notes[]={ 'R','C','C','D','D','E','F','F','G','G','A','A','B' };
char flats[]={  0 , 0,  1,  0,  1, -1,  0,  1,  0,  1,  0,  1, -1  };
char flmap[]={  0 , 1,  1,  2,  2, -1,  4,  4,  8,  8, 16, 16, -1  };
int t,d;

  t=0;

  if (note->note_count<35)
  {
    outnote[t++]=notes[note->tone];
    if (flats[note->tone]!=-1)
    {
      if (((note->flats&flmap[note->tone])==0 && flats[note->tone]==1) ||
          ((note->flats&flmap[note->tone])!=0 && flats[note->tone]==0))
      {
        outnote[t++]='#';
        note->flats^=flmap[note->tone];
      }
    }

    if (note->scale!=0)
    { outnote[t++]='+'; }

    d=6-note->length;
    outnote[t++]=d+'0';

    outnote[t]=0;

#ifdef DEBUG
printf("%s",outnote);
#endif

    fprintf(out,"%s",outnote);
  }
}

void write_mot_footer(FILE *out, struct note_t *note)
{
char outchars[20];
int ch,x,f;
int marker;

  x=0; f=0;
  marker=ftell(out);
  fseek(out,0,0);

  while ((ch=getc(out))!=EOF)
  {
    if (ch==' ') f=1;
    if (f==1) x=x^ch;
#ifdef DEBUG
printf("%d\n",x);
#endif
  }

  sprintf(outchars,"&&%c%c",((x>>4)+0x30),((x&15)+0x30));
  write_chars(out,outchars);

  if (note->note_count>35)
  {
    printf("Warning: Motorola's format only supports 35 notes.\n");
    printf("         This song has been truncated.\n");
  }
}

