#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "general.h"
#include "fileoutput.h"

/*

parse_kws() - Copyright 2001-2002 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://nakentone.naken.cc/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int get_duration(float duration);

int parse_kws(char *filename, char *outname, int file_type, struct note_t *note)
{
FILE *in,*out;
char notes[2048];
int duration[2048];
int file_length,count;
int t,a,b,ch;
int quarter_note;

  in=fopen(filename,"r");
  if (in==0)
  {
    printf("Could not open file for reading: %s\n",filename);
    return -1;
  }

  t=0;
  if (note->songname[0]==0)
  {
    while(filename[t]!='.' && filename[t]!=0 && t<14)
    {
      note->songname[t]=filename[t];
      t++;
    }
    note->songname[t]=0;
  }

  file_length=read_long(in);
  file_length=file_length^0xffffffff;
  count=read_word(in);

  fseek(in,0,SEEK_END);

  if (ftell(in)!=file_length)
  {
    printf("This is not a KWS file.\n");
    return -1;
  }
  fseek(in,6,SEEK_SET);

  if (count>2040)
  {
    printf("This song is too long.\n");
    return -1;
  }

  for (t=0; t<count; t++)
  {
    ch=getc(in);
    notes[t]=ch;
    ch=getc(in);
    if (ch!=4) notes[t]=0;

    a=getc(in);
    b=getc(in);

    a=a^(b<<1);

    duration[t]=(b<<8)+a;

    if (t==0) quarter_note=duration[t];
  }

  out=fopen(outname,"w+");
  if (out==0)
  {
    printf("Could not open file for writing: %s\n",outname);
    fclose(in);
    return -1;
  }

  t=0;
  while(t<8)
  {
    note->bpm=60000/quarter_note;
    if (note->bpm<250) break;

    quarter_note=quarter_note*2;
    t++;
  }

  t=0;
  while(t<8)
  {
    if (note->bpm>90) break;
    quarter_note=quarter_note/2;
    note->bpm=60000/quarter_note;

    t++;
  }

  header_route(out,note,0,file_type);

  for (t=0; t<count; t++)
  {
    if (notes[t]==0)
    {
      note->tone=0;
    }
      else
    {
      note->tone=(notes[t]-1)%12+1;
      note->scale=(notes[t]-1)/12;
    }

    a=get_duration((float)duration[t]/((float)quarter_note*4));
    note->length=a/2;
    note->modifier=(a%2)^1;

    note_route(out,note,0,file_type);
  }

  footer_route(out,note,0,file_type);

  fclose(in);
  fclose(out);

  return (0);
}



