#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "general.h"
#include "fileoutput.h"
#include "nokia.h"

/*

bmp2nokia_icon - Copyright 2001-2002 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://nakentone.naken.cc/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int parse_text(FILE *fp, struct note_t *note, char *picture)
{
int t,x,y,lastch,ch;
int ptr=0;

  while ((ch=getc(fp))!=EOF)
  {
    if (ch=='\n' || ch=='\r')
    {
      if ((lastch=='\r' || lastch=='\n') && ch!=lastch) continue;
      for (t=x; t<note->width; t++) picture[ptr++]=' ';
      x=0; y++;
      continue;
    }

    if (ch==' ')
    { picture[ptr++]=' '; }
      else
    { picture[ptr++]='*'; }

    x++;

    if (x>=note->width)
    {
      while ((ch=getc(fp))!=EOF)
      { if (ch=='\n' || ch=='\r') break; }
      y++;
      if (y>=note->height) break;
      x=0;
    }

    lastch=ch;
  }

  for (t=y; t<note->height; t++)
  {
    for (x=0; x<note->width; x++) picture[ptr++]=' ';
  }

  return 0;
}

int parse_logo(char *filename, char *outname, int in_type, int file_type, struct note_t *note, char *message)
{
FILE *fp,*out;
int x,y,reverse;
char picture[8192];

  if ((note->bmp_flags&1)==1)
  { reverse=1; }
    else
  { reverse=1; }

  printf("         Width: %d\n",note->width);
  printf("        Height: %d\n",note->height);
  printf("      SMS Size: %d\n",note->full_sms_size);

  if (note->mcc!=-1 && note->mnc!=-1)
  {
    printf("       MCC MNC: %d %d\n",note->mcc,note->mnc);
  }

  fp=fopen(filename,"r");
  if (fp==0)
  {
    printf("Could not open file for reading: %s\n",filename);
    return -1; 
  }

  out=fopen(outname,"w");
  if (out==0)
  {
    printf("Could not open file for reading: %s\n",outname);
    fclose(fp);
    return -1; 
  }

  if (file_type==4)
  { write_nokia_logo_header(out,note,message); }


  if (in_type==3)
  {
    if (parse_bitmap(fp,note->width,note->height,picture)==-1)
    {
      printf("Could not read BMP.\n");
      return -1; 
    }

    for (y=note->height-1; y>=0; y--)
    {
      for (x=0; x<note->width; x++)
      {
        if (picture[(y*note->width)+x]==' ')
        {
          push(1^reverse,1);
        }
          else
        {
          push(0^reverse,1);
        }
      }
    }
  }
    else
  if (in_type==4)
  {
    parse_text(fp,note,picture);

    for (y=0; y<note->height; y++)
    {
      for (x=0; x<note->width; x++)
      {
        if (picture[(y*note->width)+x]==' ')
        {
          push(1^reverse,1);
        }
          else
        {
          push(0^reverse,1);
        }
      }
    }
  }

#ifdef DEBUG
  printf("\n");
#endif


#ifdef DEBUG
  for (y=note->height-1; y>=0; y--)
  {
    for (x=0; x<note->width; x++)
    {
      if (picture[(y*note->width)+x]==' ')
      {
        printf("_");
      }
        else
      {
        printf("*");
      }
    }
    printf("\n");
  }
#endif

  write_nokia_logo_codes(out,note);

  fclose(fp);
  fclose(out);

  return (0);
}



