#include <stdio.h>
#include <stdlib.h>

#include "fileoutput.h"
#include "nokia.h"

/*

Ringtonetools - Copyright 2001-2002 Michael Kohn (mike@mikekohn.net)
This falls under the Kohnian license.  Please read
it at http://nakentone.naken.cc/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

/* RTTTL */

void write_rtttl_header(FILE *out, struct note_t *note)
{
  fprintf(out,"%s:d=8,o=5,b=%d:",note->songname,note->bpm);
}

void write_rtttl_note(FILE *out, struct note_t *note)
{
  if (note->note_count>0) fprintf(out,",");

  if (note->length!=3) fprintf(out,"%d",(1<<(note->length)));

  if (note->tone==0) fprintf(out,"p");
    else
  if (note->tone==1) fprintf(out,"c");
    else
  if (note->tone==2) fprintf(out,"c#");
    else
  if (note->tone==3) fprintf(out,"d");
    else
  if (note->tone==4) fprintf(out,"d#");
    else
  if (note->tone==5) fprintf(out,"e");
    else
  if (note->tone==6) fprintf(out,"f");
    else
  if (note->tone==7) fprintf(out,"f#");
    else
  if (note->tone==8) fprintf(out,"g");
    else
  if (note->tone==9) fprintf(out,"g#");
    else
  if (note->tone==10) fprintf(out,"a");
    else
  if (note->tone==11) fprintf(out,"a#");
    else
  if (note->tone==12) fprintf(out,"h");

  if (note->scale!=0) fprintf(out,"%d",note->scale+5);

  if (note->modifier!=0) fprintf(out,".");
}

void write_rtttl_footer(FILE *out, struct note_t *note)
{
  fprintf(out,";");
}

